<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Block\Impressions;

use Flat101\EnhancedEcommerce\Api\DataLayerListInterface;
use Flat101\EnhancedEcommerce\Block\AbstractDatalayer;
use Flat101\EnhancedEcommerce\Factory\DataLayerFactory;
use Flat101\EnhancedEcommerce\Helper\Config;
use Flat101\EnhancedEcommerce\Model\DataLayer\Impressions\SearchImpressionView;
use Magento\Framework\App\Response\RedirectInterface;
use Magento\Framework\Event\Manager;
use Magento\Framework\Serialize\SerializerInterface;
use Magento\Framework\UrlInterface;
use Magento\Framework\View\Element\Template;

class SearchImpression extends AbstractDatalayer
{
    /** @var SearchImpressionView */
    private $searchImpressionView;

    public function __construct(
        SearchImpressionView $searchImpressionView,
        Template\Context $context,
        DataLayerListInterface $dataLayerList,
        DataLayerFactory $dataLayerFactory,
        SerializerInterface $serializer,
        UrlInterface $url,
        Config $config,
        RedirectInterface $redirect,
        Manager $eventManage,
        array $data = []
    ) {
        parent::__construct($context, $dataLayerList, $dataLayerFactory, $serializer, $url, $config, $redirect, $eventManage, $data);
        $this->searchImpressionView = $searchImpressionView;
    }

    public function getJsonDataLayers(): ?string
    {
        return $this->serializer->serialize($this->searchImpressionView->getLayer());
    }
}
