define([
    'jquery'
], function ($) {
    'use strict';

    function initBefore() {
        window.dataLayer = window.dataLayer || [];
    }

    function dataLayerPush(data) {
        initBefore();
        dataLayer.push(data);
    }

    return function (options, element) {
        $(element).click(function (event) {
            let prodIdElement = $(element).closest('.product-item-info').attr('id') ? $(element).closest('.product-item-info').attr('id') : $(element).closest('.product-item').attr('id');
            let array = prodIdElement.split('_');
            let prodId = null;

            if (array.length > 0) {
                prodId = prodIdElement.split('_')[1];
            }

            if (_.has(options, 'click_data')) {
                let clickData = JSON.stringify(options.click_data[prodId]);

                $.ajax({
                    type: 'POST',
                    data: {id: prodId, currentUrl: options.currentUrl, refererUrl: options.refererUrl, clickData: clickData},
                    url: options.ajaxUrl,
                    success: (result, status) => {
                        if (_.isArray(result) && result.length > 0) {
                            result.forEach((item) => {
                                dataLayerPush(item);
                            });
                        }
                    },
                    dataType: 'json'
                });
            }
        });
    };
});
